'This script will connect to computers defined in the "computers.txt" textfile in order to retrieve the last logged-on user.
'Results will be written to the "Set_ADmanagedBy_Computers_Simulation_log.txt" textfile

WScript.Echo "Note: This is a simulation, no changes will be made to Active Directory"

Const ADS_NAME_TYPE_NT4 = 3
Const ADS_NAME_TYPE_1179 = 1

'Create a FileSystemObject
Set oFS = CreateObject("Scripting.FileSystemObject")
Set oTSOut = oFS.CreateTextFile("Set_ADmanagedBy_Computers_Simulation_log.txt")

On Error Resume Next
' Get the Domain DNS name from RootDSE
Set objRootDSE = GetObject("LDAP://RootDSE")
strDNSDomain = objRootDSE.Get("defaultNamingContext")
If Err.Number <> 0 Then
	WScript.Echo "Critical Error: *could not obtain the Active Directory domain name*" & vbCrLf & "debug: " & Err.Number & " " & Err.Description & vbCrLf & "Cannot continue, quit."
	oTSOut.WriteLine "Critical Error: *could not obtain the Active Directory domain name*" & vbCrLf & "debug: " & Err.Number & " " & Err.Description & vbCrLf & "Cannot continue, quit."
	Err.Clear
	WScript.Quit(1)
Else
	Set objTrans = CreateObject("NameTranslate")
	objTrans.Init ADS_NAME_TYPE_NT4, strDNSDomain
	objTrans.Set ADS_NAME_TYPE_1179, strDNSDomain
	strNetBIOSDomain = objTrans.Get(ADS_NAME_TYPE_NT4)
	'Remove trailing backslashes
	strNetBIOSDomain = Left(strNetBIOSDomain, Len(strNetBIOSDomain) - 1)
	
	If Not oFS.FileExists("computers.txt") Then
		WScript.Echo "Critical Error: *computers.txt file not found*" & vbCrLf & "Cannot continue, quit."
		oTSOut.WriteLine "Critical Error: *computers.txt file not found*" & vbCrLf & "Cannot continue, quit."
		Err.Clear
		WScript.Quit(1)
	Else
		'Open a text file of computer names
		'one computer name per line
		Set oTS = oFS.OpenTextFile("computers.txt")
		Dim arrComputers()
		i = 0
		
		'go through the text file and load computer names in arrComputers
		Do Until oTS.AtEndOfStream
			ReDim Preserve arrComputers(i)
			arrComputers(i) = Trim(oTS.ReadLine)
			i = i +1
		Loop
		
		If arrComputers(0) = "" Then
			WScript.Echo "Critical Error: *computers.txt file is empty*" & vbCrLf & "Cannot continue, quit."
			oTSOut.WriteLine "Critical Error: *computers.txt file is empty*" & vbCrLf & "Cannot continue, quit."
			WScript.Quit(1)
		Else
			For i=0 To UBound(arrComputers)
				On Error Resume Next
				strComputer = ""
				strUserName = ""
				strError = ""
				Err.Clear
				
				'get next computer
				strComputer = arrComputers(i)
				
				Set objWMIService = GetObject("winmgmts:" & "{impersonationLevel=impersonate}!\\" & strComputer & "\root\cimv2")
				If Err.Number <> 0 Then
					strError = strComputer & vbTab & "error *could not connect to the remote computer* debug: " & Err.Number & " " & Err.Description
					Err.Clear
				Else
					Set colComputer = objWMIService.ExecQuery ("Select * from Win32_ComputerSystem")
					
					For Each objComputer In colComputer
						If Not IsNull(objComputer.UserName) Then
							strUserName = objComputer.UserName
						Else
							Set objRemoteRegistry=GetObject("winmgmts:\\" & strComputer & "\root\default:StdRegProv")
							If Err.Number <> 0 Then
								strError = strComputer & vbTab & "error: *could not connect to the remote windows registry* debug: " & Err.Number & " " & Err.Description
								Err.Clear
							Else
								objRemoteRegistry.GetStringValue &H80000002, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\WinLogon\" & key,"DefaultUserName",strUserName
								If IsNull(strUserName) Then
									strError = strComputer & vbTab & "error: *could not open DefaultUserName registry key*"
									Err.Clear
								End If
							End If
						End If
					Next
				End If
				
				If Trim(strUserName) <> "" Then
					If (Right(Trim(strComputer), 1) <> "$") Then
						strComputer = Trim(strComputer) & "$"
					Else
						strComputer = Trim(strComputer)
					End If
					
					objTrans.Set ADS_NAME_TYPE_NT4, strNetBIOSDomain & "\" & strComputer
					strComputerDN = objTrans.Get(ADS_NAME_TYPE_1179)
					Set objADComputer = GetObject("LDAP://" & strComputerDN)
					If Err.Number <> 0 Then
						strError = strComputer & vbTab & "error: *could not connect to the AD computer object* debug: " & Err.Number & " " & Err.Description
						Err.Clear
					Else
						If InStr(strUserName, strNetBIOSDomain & "\") Then
							strUserName = Replace(strUserName, strNetBIOSDomain & "\", "")
						End If
						
						objTrans.Set ADS_NAME_TYPE_NT4, strNetBIOSDomain & "\" & strUserName
						strUserDN = objTrans.Get(ADS_NAME_TYPE_1179)
						Set objADUser = GetObject("LDAP://" & strUserDN)
						If Err.Number <> 0 Then
							strError = strComputer & vbTab & "error: *could not connect to the AD user object* debug: " & Err.Number & " " & Err.Description
							Err.Clear	
						Else	
							If Trim(strError) = "" Then
								oTSOut.WriteLine strComputer & vbTab & strUserName
							End If
						End If
					End If
				End If
				
				If Trim(strError) <> "" Then
					oTSOut.WriteLine strError
				End If
			Next
			WScript.Echo "Done - check the logfile for details"
		End If
	End If
End If

oTS.Close
oTSOut.Close
WScript.Quit(0)